#include <windows.h>
#include <windowsx.h>

//____________________________________________________________________________________________
//____________________________________________________________________________________________
//
BOOL InitApplication (HINSTANCE hInstance);//. 
BOOL InitInstance (HINSTANCE hInstance, int CmdShow);//.  
LRESULT CALLBACK WndProc (HWND hWnd, UINT Message,WPARAM wParam, LPARAM lParam);// 
void DrawTime();// 
void MoveClock();// 
void ShowMenu();// 
void EndRegistry();//   
void StartRegistry();// 
void InitRegistry();
void ReadRegistry();
void StartClock();// 
void EndClock();// 
void SetFont();//  
void SetFontInit();//    
void SetColor();// 
void SetColorInit();//    
void MenuProc( WPARAM );// 
void ClockPos();//  
//void DebugProc ();// 
//void DebugProcRegistry ( long );// 
//void Dbg (long);// 
void BackDraw ( );
//____________________________________________________________________________________________
//____________________________________________________________________________________________
//
LPCSTR szClassName="KitoClock";//  
LPCSTR szTitle=" KitoClock";//
LPCTSTR MENU_1="Font...";// 
LPCTSTR MENU_2="Color...";
LPCTSTR MENU_3="Exit";

LPCSTR KitoProg= " ";
LPCSTR SoftWare= "Software";
LPCSTR KitoWrite= "   ";
LPCSTR KitoClock= "KitoClock";
LPCSTR LearningExample= "       ";
LPCSTR LongKey= "Software\\ \\KitoClock";
LPCSTR MidiKey= "Software\\ ";
LPCSTR Color= "Color";
LPCSTR Left= "Left";
LPCSTR Top= "Top";
LPCSTR FontName= "FontName";
LPCSTR FontBold= "FontBold";
LPCSTR FontItalic= "FontItalic";
LPCSTR FontSize= "FontSize";

UINT ID_1=2000;// 
UINT ID_2=2001;
UINT ID_3=2002;

LPCTSTR PTEXT="12345678";//   - 8 

LPCTSTR TIMEFORMAT="hh':'mm':'ss";//  

HWND hWnd;//  
HDC hDc;// 

HMENU NewContextMenu;// 
long tmrID;// 
long di;// 
COLORREF clrTitleColor =1555555;//,  
LOGFONT logFontClock;//,    
CHOOSEFONT chFnt;// 

TEXTMETRIC tmtTextMetric;//,     (   )

long longFontUsed;// 
long longOldHDC;//  

RECT rctRect;//,   

char * strFontName="Courier";// -  

long coordLeft;// 
long coordTop;
long coordWidth;
long coordHeight;

UINT INTERVAL =1000; // "" 

HBRUSH Brush;//  

CHOOSECOLOR chClr;//  
COLORREF arCc[16];//.    ( .)

long MISSED_KEY= 2;//    

WNDCLASS wc;//  

PAINTSTRUCT ps;

//____________________________________________________________________________________________
//____________________________________________________________________________________________
// 
int WINAPI WinMain (
					HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow)
{
	MSG msg;//

	if (!hPrevInstance)//
	{
		if (!InitApplication (hInstance))//    - 
			return FALSE;
	}

	if (!InitInstance (hInstance, nCmdShow))//     - 
		return FALSE;

	while (GetMessage (&msg, NULL, 0, 0))// 
	{
		TranslateMessage (&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}
//____________________________________________________________________________________________
//   

BOOL InitApplication (HINSTANCE hInstance)
{
StartClock();//    

wc.cbClsExtra=0;//         ,
				//   
wc.cbWndExtra=0;//       , 
				//  
wc.hbrBackground=NULL;//   - ,    (   
												//  ).
wc.hCursor= LoadCursor (NULL, IDC_ARROW);//  
wc.hIcon=0;// 
wc.hInstance=hInstance;// ,     
wc.lpfnWndProc=(WNDPROC)WndProc;//   
wc.lpszClassName=szClassName;//  
wc.lpszMenuName=NULL;//   (  )
//wc.style=CS_HREDRAW | CS_VREDRAW | CS_BYTEALIGNWINDOW;// 
wc.style=CS_SAVEBITS;//  (    )...

	return RegisterClass (&wc);//    
}
//____________________________________________________________________________________________

BOOL InitInstance (HINSTANCE hInstance, int nCmdShow)
{
	//  
	hWnd=CreateWindowEx (WS_EX_TOOLWINDOW,
		szClassName,
		NULL,
		WS_BORDER | WS_POPUP | WS_MINIMIZE,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL
		);

	if (!hWnd)
		return FALSE;

	hDc=GetWindowDC (hWnd);//   

	//     ""
	SetBkMode(hDc, TRANSPARENT);

	ShowWindow (hWnd, nCmdShow);// 
	UpdateWindow (hWnd);// 

	//  
	SetFontInit();

	//  
	SetColorInit();

	ps.hdc= hDc;//    
	ps.rcPaint= rctRect;
	ps.fErase=TRUE;
	ps.fIncUpdate=NULL;
	ps.fRestore= NULL;

	//  
	DrawTime();

	return TRUE;
}
//____________________________________________________________________________________________
// 

LRESULT CALLBACK WndProc (HWND hWnd, UINT Message,WPARAM wParam, LPARAM lParam)
{
	//   
	switch (Message)
	{
		//    - 
	case WM_COMMAND:
			MenuProc (wParam);
			break;
		//    -  
		case WM_LBUTTONDOWN:
			MoveClock();
			break;
		//    -  
		case WM_RBUTTONDOWN:
			ShowMenu();
			break;
		//     -   
		case WM_ERASEBKGND:
			BackDraw ();
			break;
	//  
	case WM_DESTROY:
		// 
		EndClock();// 
		PostQuitMessage (0);//  ""
		break;
	default:
		//   -   "" 
		return DefWindowProc (hWnd, Message, wParam, lParam);
	}

	return 0;

}
//____________________________________________________________________________________________
// 

void DrawTime()
{
	char  TXT [9];
	SYSTEMTIME timTime;
	HRGN hRgn;

	// 
	GetLocalTime ( &timTime);
	//     
	GetTimeFormat (0L, TIME_FORCE24HOURFORMAT, & timTime, TIMEFORMAT, TXT, 10);

	// ""
	BeginPath (hDc);

	// -
	TextOut (hDc, 0, 0, TXT, strlen (TXT));

	// 
	EndPath (hDc);

	//   
	hRgn=PathToRegion (hDc);

	// 
	SetWindowRgn (hWnd, hRgn, TRUE);

}
//____________________________________________________________________________________________
//      
void EndRegistry ()
{
	long lLen= 80;// 
	HKEY  hkRoot;//  
	long x;//. 
	char * strKeyID;//  
	unsigned char strKeyDesc[80];/*= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0};// , */
	long AppName;//. .
	char * arAppName;//. .
	long Buffer=lLen;//    

	strKeyID= KitoProg;
	
	//  SoftWare
	x= RegOpenKeyEx (HKEY_CURRENT_USER, SoftWare, NULL, KEY_ALL_ACCESS, &hkRoot);

	//   KitoProg?
	x= RegQueryValue (hkRoot, KitoProg, strKeyDesc, &Buffer);

	//  - 
   	if (x== MISSED_KEY)
		x= RegSetValue (hkRoot, strKeyID, 1L, KitoWrite, 0L);

	strKeyID= KitoClock;

	//  
	x= RegOpenKeyEx (HKEY_CURRENT_USER, MidiKey, NULL, KEY_ALL_ACCESS, &hkRoot);

	//   KitoClock?
	x= RegQueryValue (hkRoot, strKeyID, strKeyDesc, &Buffer);

	//  - 
	if (x== MISSED_KEY)
		x= RegSetValue (hkRoot, strKeyID, 1L, LearningExample, 0L);

	//   
	x= RegOpenKeyEx (HKEY_CURRENT_USER, LongKey, NULL, KEY_ALL_ACCESS, &hkRoot);

	//  
	Buffer=4;

	x= RegSetValueEx (hkRoot, Color, NULL, REG_DWORD, &clrTitleColor, 4L);

	AppName= coordLeft;
	x= RegSetValueEx (hkRoot, Left, NULL, REG_DWORD, &AppName, 4L);
	
	AppName= coordTop;
	x= RegSetValueEx (hkRoot, Top, NULL, REG_DWORD, &AppName, 4L);

	arAppName= strFontName;
	x= RegSetValueEx (hkRoot, FontName, NULL, REG_SZ, arAppName, strlen (arAppName));

	AppName= logFontClock.lfWeight;
	x= RegSetValueEx (hkRoot, FontBold, NULL, REG_DWORD, &AppName, 4L);

	AppName=logFontClock.lfItalic;
	x= RegSetValueEx (hkRoot, FontItalic, NULL, REG_DWORD, &AppName, 4L);

//	if (logFontClock.lfHeight >0)
		AppName= chFnt.iPointSize / 10;
//	else
//		AppName= -MulDiv( logFontClock.lfHeight, GetDeviceCaps (hDc, LOGPIXELSY), 72);
	x= RegSetValueEx (hkRoot, FontSize, NULL, REG_DWORD, &AppName, 4L);

	// 
	x= RegCloseKey (hkRoot);
}
//____________________________________________________________________________________________
//  ,   -
void InitRegistry()
{
	long lLen= 80;
	HKEY  hkRoot;
	long x;
	char * strKeyID;
	unsigned char strKeyDesc[80];/*= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
											 0, 0, 0, 0, 0, 0, 0};*/
	long AppName;
	char * arAppName;
	long Buffer=lLen;


	//
	//   .   EndRegistry
	//
	strKeyID= KitoProg;

	x= RegOpenKeyEx (HKEY_CURRENT_USER, SoftWare, NULL, KEY_ALL_ACCESS, &hkRoot);

	x= RegQueryValue (hkRoot, KitoProg, strKeyDesc, &Buffer);

   	if (x== MISSED_KEY)
		x= RegSetValue (hkRoot, strKeyID, 1L, KitoWrite, 0L);

	strKeyID= KitoClock;

	x= RegOpenKeyEx (HKEY_CURRENT_USER, MidiKey, NULL, KEY_ALL_ACCESS, &hkRoot);

	x= RegQueryValue (hkRoot, strKeyID, strKeyDesc, &Buffer);

	if (x== MISSED_KEY)
		x= RegSetValue (hkRoot, strKeyID, 1L, LearningExample, 0L);

	x= RegOpenKeyEx (HKEY_CURRENT_USER, LongKey, NULL, KEY_ALL_ACCESS, &hkRoot);

	Buffer=4;

	x= RegQueryValueEx (hkRoot, Color, NULL, NULL, &clrTitleColor, &Buffer);

	if (x==0)
		return TRUE;

	x= RegSetValueEx (hkRoot, Color, NULL, REG_DWORD, &clrTitleColor, 4L);

	AppName= 500;
	x= RegSetValueEx (hkRoot, Left, NULL, REG_DWORD, &AppName, 4L);
	
	AppName= 200;
	x= RegSetValueEx (hkRoot, Top, NULL, REG_DWORD, &AppName, 4L);

	arAppName= "Arial";
	x= RegSetValueEx (hkRoot, FontName, NULL, REG_SZ, arAppName, strlen (arAppName));

	AppName= 20;
	x= RegSetValueEx (hkRoot, FontBold, NULL, REG_DWORD, &AppName, 4L);

	AppName= FALSE;
	x= RegSetValueEx (hkRoot, FontItalic, NULL, REG_DWORD, &AppName, 4L);

	AppName= 72;
	x= RegSetValueEx (hkRoot, FontSize, NULL, REG_DWORD, &AppName, 4L);

	x= RegCloseKey (hkRoot);

}
//____________________________________________________________________________________________
//      
void MoveClock ()
{

	ReleaseCapture();//  
	SendMessage (hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0L);// 

	//        
	ClockPos();

}
//____________________________________________________________________________________________
//      
void ShowMenu ()
{
	POINT pt;

	GetCursorPos ( &pt);//  

	di=TrackPopupMenu (NewContextMenu, TPM_CENTERALIGN, pt.x, pt.y, 0, hWnd, NULL);//  
											//  
}
//____________________________________________________________________________________________
// 
void StartClock ()
{
	// 
	StartRegistry();
	// 
	NewContextMenu=CreatePopupMenu();
	//   
	AppendMenu (NewContextMenu, MF_STRING, ID_1, MENU_1);
	AppendMenu (NewContextMenu, MF_STRING, ID_2, MENU_2);
	AppendMenu (NewContextMenu, MF_STRING, ID_3, MENU_3);

	// ,    
	tmrID=SetTimer(hWnd, 0, INTERVAL, (TIMERPROC)DrawTime);

}
//____________________________________________________________________________________________
//  
void EndClock ()
{

	if (NewContextMenu)//  
		DestroyMenu (NewContextMenu);// 

	KillTimer (hWnd, tmrID);// 

	EndRegistry();//   

}
//____________________________________________________________________________________________
// 
void SetFont ()
{

	//     -  
	chFnt.hwndOwner=hWnd;
	logFontClock.lfHeight= chFnt.iPointSize /10;
	chFnt.Flags=CF_SCREENFONTS | CF_TTONLY | CF_INITTOLOGFONTSTRUCT;
	chFnt.lpLogFont= & logFontClock;
	chFnt.lStructSize= sizeof (CHOOSEFONT);

	// 
	//   - 
	if (!ChooseFont (&chFnt))
		return FALSE;

	//    
	SetFontInit ();
		return TRUE;

}
//____________________________________________________________________________________________
//    
void SetFontInit ()
{
	long xX, yY;// -

	// 
	// 
	logFontClock.lfCharSet = DEFAULT_CHARSET;
    logFontClock.lfClipPrecision = OUT_DEFAULT_PRECIS;
    logFontClock.lfEscapement = 0;
    logFontClock.lfOrientation = 0;
    logFontClock.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFontClock.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
    logFontClock.lfQuality = DEFAULT_QUALITY;
	logFontClock.lfHeight= chFnt.iPointSize/ 4;

	//     -  

	// 
     longFontUsed = CreateFontIndirect( &logFontClock);

	 //  
	longOldHDC = SelectObject(hDc, longFontUsed);

	xX=coordLeft;//   , . .     
	yY=coordTop;

	//  ,   
	ClockPos();

	//  
	SetWindowPos (hWnd, HWND_TOPMOST, xX, yY, coordWidth, 
                                           coordHeight, SWP_SHOWWINDOW);

}
//____________________________________________________________________________________________
// 
void SetColor ()
{

	//  
	chClr.rgbResult=clrTitleColor;// 

	//   - 
	if (!ChooseColor (&chClr))
		return FALSE;

	//   
	clrTitleColor= chClr.rgbResult;

	SetColorInit();
		return TRUE;
}
//____________________________________________________________________________________________
// 
void MenuProc(WPARAM wPar)
{
		switch (wPar)//     
		{
		case 2000:
			SetFont();// 
			break;
		case 2001:
			SetColor();//  
			break;
		case 2002:
			// 
			EndClock();// 
			PostQuitMessage (0);//  ""
		}
}
//____________________________________________________________________________________________
//  
void ClockPos()
{
	//    - coordLeft, Top, Width, Height

	//  
	GetTextMetrics (hDc, &tmtTextMetric);
	// 
	GetWindowRect (hWnd, &rctRect);//  

	coordLeft= rctRect.left;//     (  )
	coordTop= rctRect.top;
	//    -     
	coordWidth= tmtTextMetric.tmAveCharWidth  * 10;
	coordHeight= tmtTextMetric.tmHeight * 1.3;
}
//____________________________________________________________________________________________
//    
void SetColorInit()
{
	// 
	chClr.lStructSize= sizeof (CHOOSECOLOR);//
	chClr.hwndOwner=hWnd;// 
	chClr.lpCustColors= (LPDWORD) arCc;//   ( )
	chClr.rgbResult=clrTitleColor;//  ( )
	chClr.Flags= CC_RGBINIT;// 

	//     -  
	if (Brush)
	DeleteObject (Brush);

	// 
	Brush= CreateSolidBrush (clrTitleColor);

	//  
	SelectObject (hDc, Brush);

	//    
	ClockPos();

}
//____________________________________________________________________________________________
// 
void StartRegistry()
{
	InitRegistry();
	ReadRegistry();
}
//____________________________________________________________________________________________
void ReadRegistry ()
{

	HKEY hkRoot;
	long x;
	unsigned char strKeyDesc[32];//= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	long AppName;
	long Buffer;
	long lLen= 32;

	//
	//   .   EndRegistry
	//
	x= RegOpenKeyEx (HKEY_CURRENT_USER, LongKey, NULL, KEY_ALL_ACCESS, &hkRoot);

	Buffer=4;
	x= RegQueryValueEx (hkRoot, Color, NULL, NULL, &clrTitleColor, &Buffer);

	x= RegQueryValueEx (hkRoot, Left, NULL, NULL, &coordLeft, &Buffer);

	x= RegQueryValueEx (hkRoot, Top, NULL, NULL, &coordTop, &Buffer);

	Buffer=lLen;
	
	x= RegQueryValueEx (hkRoot, FontName, NULL, NULL, logFontClock.lfFaceName, &Buffer);

	strFontName= logFontClock.lfFaceName;

	Buffer=4;
	
	x= RegQueryValueEx (hkRoot, FontBold, NULL, NULL, &AppName, &Buffer);
	logFontClock.lfWeight= AppName;

	x= RegQueryValueEx (hkRoot, FontItalic, NULL, NULL, &AppName, &Buffer);
	logFontClock.lfItalic= AppName;

	x= RegQueryValueEx (hkRoot, FontSize, NULL, NULL, &AppName, &Buffer);
	//    
	chFnt.iPointSize=AppName * 10;

	x= RegCloseKey (hkRoot);

}
//____________________________________________________________________________________________
/*void DebugProc ()
{
// 
LPVOID lpMsgBuf;
 
FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
);

// Display the string.
MessageBox( NULL, lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

// Free the buffer.
LocalFree( lpMsgBuf );

}
//____________________________________________________________________________________________
void DebugProcRegistry (long w)
{
// 
LPVOID lpMsgBuf;
 
FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    w,
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
);

// Display the string.
MessageBox( NULL, lpMsgBuf, "Registry", MB_OK|MB_ICONINFORMATION );

// Free the buffer.
LocalFree( lpMsgBuf );

}
//____________________________________________________________________________________________
void Dbg (long e)
{

	DebugProc();
	DebugProcRegistry(e);

}
//____________________________________________________________________________________________
*/
//____________________________________________________________________________________________
void BackDraw ()//  
{
// 
	BeginPaint (hWnd, &ps);
//    
    GetClientRect(hWnd, &rctRect); 
//  
    FillRect(hDc, &rctRect, Brush); 
// 
	EndPaint (hWnd, &ps);

}
//____________________________________________________________________________________________


